curl --request POST \
--url https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId} \
--header 'Authorization: <api-key>' \
--header 'Content-Type: application/json-patch+json' \
--data '
{
"title": "Item added to cart",
"description": "Occurs when customer adds item to cart, without checkout. Carries information about items added",
"fields": [
{
"name": "transactionId",
"type": "String"
},
{
"name": "fromPromoCampaign",
"type": "Boolean"
},
{
"name": "totalCost",
"type": "Decimal"
},
{
"name": "itemsInCart",
"type": "List",
"schema": {
"type": "Object",
"fields": [
{
"name": "itemId",
"type": "Decimal"
},
{
"name": "price",
"type": "Decimal"
},
{
"name": "quantity",
"type": "Decimal"
},
{
"name": "inStockSince",
"type": "DateTime"
},
{
"name": "category",
"type": "String"
}
]
}
}
]
}
'import requests
url = "https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}"
payload = {
"title": "Item added to cart",
"description": "Occurs when customer adds item to cart, without checkout. Carries information about items added",
"fields": [
{
"name": "transactionId",
"type": "String"
},
{
"name": "fromPromoCampaign",
"type": "Boolean"
},
{
"name": "totalCost",
"type": "Decimal"
},
{
"name": "itemsInCart",
"type": "List",
"schema": {
"type": "Object",
"fields": [
{
"name": "itemId",
"type": "Decimal"
},
{
"name": "price",
"type": "Decimal"
},
{
"name": "quantity",
"type": "Decimal"
},
{
"name": "inStockSince",
"type": "DateTime"
},
{
"name": "category",
"type": "String"
}
]
}
}
]
}
headers = {
"Authorization": "<api-key>",
"Content-Type": "application/json-patch+json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "<api-key>");
request.AddJsonBody("{\n \"title\": \"Item added to cart\",\n \"description\": \"Occurs when customer adds item to cart, without checkout. Carries information about items added\",\n \"fields\": [\n {\n \"name\": \"transactionId\",\n \"type\": \"String\"\n },\n {\n \"name\": \"fromPromoCampaign\",\n \"type\": \"Boolean\"\n },\n {\n \"name\": \"totalCost\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"itemsInCart\",\n \"type\": \"List\",\n \"schema\": {\n \"type\": \"Object\",\n \"fields\": [\n {\n \"name\": \"itemId\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"price\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"quantity\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"inStockSince\",\n \"type\": \"DateTime\"\n },\n {\n \"name\": \"category\",\n \"type\": \"String\"\n }\n ]\n }\n }\n ]\n}", false);
var response = await client.PostAsync(request);
Console.WriteLine("{0}", response.Content);
HttpResponse<String> response = Unirest.post("https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}")
.header("Authorization", "<api-key>")
.header("Content-Type", "application/json-patch+json")
.body("{\n \"title\": \"Item added to cart\",\n \"description\": \"Occurs when customer adds item to cart, without checkout. Carries information about items added\",\n \"fields\": [\n {\n \"name\": \"transactionId\",\n \"type\": \"String\"\n },\n {\n \"name\": \"fromPromoCampaign\",\n \"type\": \"Boolean\"\n },\n {\n \"name\": \"totalCost\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"itemsInCart\",\n \"type\": \"List\",\n \"schema\": {\n \"type\": \"Object\",\n \"fields\": [\n {\n \"name\": \"itemId\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"price\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"quantity\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"inStockSince\",\n \"type\": \"DateTime\"\n },\n {\n \"name\": \"category\",\n \"type\": \"String\"\n }\n ]\n }\n }\n ]\n}")
.asString();<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'title' => 'Item added to cart',
'description' => 'Occurs when customer adds item to cart, without checkout. Carries information about items added',
'fields' => [
[
'name' => 'transactionId',
'type' => 'String'
],
[
'name' => 'fromPromoCampaign',
'type' => 'Boolean'
],
[
'name' => 'totalCost',
'type' => 'Decimal'
],
[
'name' => 'itemsInCart',
'type' => 'List',
'schema' => [
'type' => 'Object',
'fields' => [
[
'name' => 'itemId',
'type' => 'Decimal'
],
[
'name' => 'price',
'type' => 'Decimal'
],
[
'name' => 'quantity',
'type' => 'Decimal'
],
[
'name' => 'inStockSince',
'type' => 'DateTime'
],
[
'name' => 'category',
'type' => 'String'
]
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>",
"Content-Type: application/json-patch+json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'application/json-patch+json'},
body: JSON.stringify({
title: 'Item added to cart',
description: 'Occurs when customer adds item to cart, without checkout. Carries information about items added',
fields: [
{name: 'transactionId', type: 'String'},
{name: 'fromPromoCampaign', type: 'Boolean'},
{name: 'totalCost', type: 'Decimal'},
{
name: 'itemsInCart',
type: 'List',
schema: {
type: 'Object',
fields: [
{name: 'itemId', type: 'Decimal'},
{name: 'price', type: 'Decimal'},
{name: 'quantity', type: 'Decimal'},
{name: 'inStockSince', type: 'DateTime'},
{name: 'category', type: 'String'}
]
}
}
]
})
};
fetch('https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));{
"isInternalDefinition": false,
"category": "external",
"definitionId": "addToCart",
"title": "Item added to cart",
"description": "Occurs when customer adds item to cart, without checkout. Carries information about items added",
"fields": [
{
"name": "transactionId",
"type": "String"
},
{
"name": "fromPromoCampaign",
"type": "Boolean"
},
{
"name": "totalCost",
"type": "Decimal"
},
{
"name": "itemsInCart",
"type": "List",
"schema": {
"type": "Object",
"fields": [
{
"name": "itemId",
"type": "Decimal"
},
{
"name": "price",
"type": "Decimal"
},
{
"name": "quantity",
"type": "Decimal"
},
{
"name": "inStockSince",
"type": "DateTime"
},
{
"name": "category",
"type": "String"
}
]
}
}
]
}{
"requestError": {
"serviceException": {
"messageId": "UNAUTHORIZED",
"text": "Unauthorized"
}
}
}{
"requestError": {
"serviceException": {
"messageId": "FORBIDDEN",
"text": "Forbidden"
}
}
}{
"requestError": {
"serviceException": {
"messageId": "GENERAL_ERROR",
"text": "Something went wrong. Please contact support."
}
}
}Update Event Definition
Update an existing custom event definition by adding new fields or modifying the title and description. Only supports additive changes—you can add new fields but cannot remove existing fields or change their types. This ensures backward compatibility with historical events. Standard (internal) definitions and template-inherited properties cannot be modified.
Required scope: Enable one of: people:manage.
curl --request POST \
--url https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId} \
--header 'Authorization: <api-key>' \
--header 'Content-Type: application/json-patch+json' \
--data '
{
"title": "Item added to cart",
"description": "Occurs when customer adds item to cart, without checkout. Carries information about items added",
"fields": [
{
"name": "transactionId",
"type": "String"
},
{
"name": "fromPromoCampaign",
"type": "Boolean"
},
{
"name": "totalCost",
"type": "Decimal"
},
{
"name": "itemsInCart",
"type": "List",
"schema": {
"type": "Object",
"fields": [
{
"name": "itemId",
"type": "Decimal"
},
{
"name": "price",
"type": "Decimal"
},
{
"name": "quantity",
"type": "Decimal"
},
{
"name": "inStockSince",
"type": "DateTime"
},
{
"name": "category",
"type": "String"
}
]
}
}
]
}
'import requests
url = "https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}"
payload = {
"title": "Item added to cart",
"description": "Occurs when customer adds item to cart, without checkout. Carries information about items added",
"fields": [
{
"name": "transactionId",
"type": "String"
},
{
"name": "fromPromoCampaign",
"type": "Boolean"
},
{
"name": "totalCost",
"type": "Decimal"
},
{
"name": "itemsInCart",
"type": "List",
"schema": {
"type": "Object",
"fields": [
{
"name": "itemId",
"type": "Decimal"
},
{
"name": "price",
"type": "Decimal"
},
{
"name": "quantity",
"type": "Decimal"
},
{
"name": "inStockSince",
"type": "DateTime"
},
{
"name": "category",
"type": "String"
}
]
}
}
]
}
headers = {
"Authorization": "<api-key>",
"Content-Type": "application/json-patch+json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "<api-key>");
request.AddJsonBody("{\n \"title\": \"Item added to cart\",\n \"description\": \"Occurs when customer adds item to cart, without checkout. Carries information about items added\",\n \"fields\": [\n {\n \"name\": \"transactionId\",\n \"type\": \"String\"\n },\n {\n \"name\": \"fromPromoCampaign\",\n \"type\": \"Boolean\"\n },\n {\n \"name\": \"totalCost\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"itemsInCart\",\n \"type\": \"List\",\n \"schema\": {\n \"type\": \"Object\",\n \"fields\": [\n {\n \"name\": \"itemId\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"price\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"quantity\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"inStockSince\",\n \"type\": \"DateTime\"\n },\n {\n \"name\": \"category\",\n \"type\": \"String\"\n }\n ]\n }\n }\n ]\n}", false);
var response = await client.PostAsync(request);
Console.WriteLine("{0}", response.Content);
HttpResponse<String> response = Unirest.post("https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}")
.header("Authorization", "<api-key>")
.header("Content-Type", "application/json-patch+json")
.body("{\n \"title\": \"Item added to cart\",\n \"description\": \"Occurs when customer adds item to cart, without checkout. Carries information about items added\",\n \"fields\": [\n {\n \"name\": \"transactionId\",\n \"type\": \"String\"\n },\n {\n \"name\": \"fromPromoCampaign\",\n \"type\": \"Boolean\"\n },\n {\n \"name\": \"totalCost\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"itemsInCart\",\n \"type\": \"List\",\n \"schema\": {\n \"type\": \"Object\",\n \"fields\": [\n {\n \"name\": \"itemId\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"price\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"quantity\",\n \"type\": \"Decimal\"\n },\n {\n \"name\": \"inStockSince\",\n \"type\": \"DateTime\"\n },\n {\n \"name\": \"category\",\n \"type\": \"String\"\n }\n ]\n }\n }\n ]\n}")
.asString();<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'title' => 'Item added to cart',
'description' => 'Occurs when customer adds item to cart, without checkout. Carries information about items added',
'fields' => [
[
'name' => 'transactionId',
'type' => 'String'
],
[
'name' => 'fromPromoCampaign',
'type' => 'Boolean'
],
[
'name' => 'totalCost',
'type' => 'Decimal'
],
[
'name' => 'itemsInCart',
'type' => 'List',
'schema' => [
'type' => 'Object',
'fields' => [
[
'name' => 'itemId',
'type' => 'Decimal'
],
[
'name' => 'price',
'type' => 'Decimal'
],
[
'name' => 'quantity',
'type' => 'Decimal'
],
[
'name' => 'inStockSince',
'type' => 'DateTime'
],
[
'name' => 'category',
'type' => 'String'
]
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>",
"Content-Type: application/json-patch+json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'application/json-patch+json'},
body: JSON.stringify({
title: 'Item added to cart',
description: 'Occurs when customer adds item to cart, without checkout. Carries information about items added',
fields: [
{name: 'transactionId', type: 'String'},
{name: 'fromPromoCampaign', type: 'Boolean'},
{name: 'totalCost', type: 'Decimal'},
{
name: 'itemsInCart',
type: 'List',
schema: {
type: 'Object',
fields: [
{name: 'itemId', type: 'Decimal'},
{name: 'price', type: 'Decimal'},
{name: 'quantity', type: 'Decimal'},
{name: 'inStockSince', type: 'DateTime'},
{name: 'category', type: 'String'}
]
}
}
]
})
};
fetch('https://api.messaging.phonovation.com/peopleevents/2/definitions/{definitionId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));{
"isInternalDefinition": false,
"category": "external",
"definitionId": "addToCart",
"title": "Item added to cart",
"description": "Occurs when customer adds item to cart, without checkout. Carries information about items added",
"fields": [
{
"name": "transactionId",
"type": "String"
},
{
"name": "fromPromoCampaign",
"type": "Boolean"
},
{
"name": "totalCost",
"type": "Decimal"
},
{
"name": "itemsInCart",
"type": "List",
"schema": {
"type": "Object",
"fields": [
{
"name": "itemId",
"type": "Decimal"
},
{
"name": "price",
"type": "Decimal"
},
{
"name": "quantity",
"type": "Decimal"
},
{
"name": "inStockSince",
"type": "DateTime"
},
{
"name": "category",
"type": "String"
}
]
}
}
]
}{
"requestError": {
"serviceException": {
"messageId": "UNAUTHORIZED",
"text": "Unauthorized"
}
}
}{
"requestError": {
"serviceException": {
"messageId": "FORBIDDEN",
"text": "Forbidden"
}
}
}{
"requestError": {
"serviceException": {
"messageId": "GENERAL_ERROR",
"text": "Something went wrong. Please contact support."
}
}
}Authorizations
This is the most secure authorization type and the one with the most flexibility.
API keys can be generated by calling the dedicated API method. Furthermore, API keys can have a limited scope and cover only some API methods. Lastly, they can be revoked at any time. This range of possibilities makes API keys well suited for separating the API access rights across multiple applications or use cases. Finally, the loss of an API key is easily manageable.
You can manage your API keys from GUI, or programmatically with dedicated API.
API key Authorization header example:
Authorization: App 003026bbc133714df1834b8638bb496e-8f4b3d9a-e931-478d-a994-28a725159ab9
Path Parameters
Event definition identifier.
Body
Event definition title. Must not be empty. Maximum length: 100 characters.
Note: The title cannot be changed for a template definition. If the client tries to update the value, it will be overwritten with the standard title from the template.
1 - 100Event definition description. Maximum length: 2000 characters.
Note: The description cannot be changed for a template definition. If the client tries to update the value, it will be overwritten with the standard description from the template.
2000Event definition fields. The total number of fields cannot exceed 120. Field names must be unique (case-insensitive). The number of fields of type List cannot exceed 1. Only new fields can be added; existing fields cannot be removed or changed.
120Show child attributes
Show child attributes
Response
OK
Indicates whether this is a standard (internal) event definition provided by the system, or a custom (external) definition created by the user.
Event definition category.
external, person, channel, product, template Event definition subcategory.
sms, email, push, whatsapp, viber, facebook, moments, forms, conversations, mobileapp, voice, line, appleBC, rcs, mms, viberBot, inapp, answers, blocklist Event definition identifier.
Event definition title.
Event definition description.
Event definition fields describing the structure and data types of the event properties.
Show child attributes
Show child attributes